/*
** Module   : GuiWebEmulatedWindow.java
** Abstract : core GUI renderer for web client
**
** Copyright (c) 2015, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- ---------------------------------Description---------------------------------
** 001 GES 20150504 First version.
*/

package com.goldencode.p2j.ui.client.gui.driver.web;

// TODO: remove this, it is there to allow compilation
import java.awt.Font;
import java.awt.image.BufferedImage;

import com.goldencode.p2j.ui.client.*;
import com.goldencode.p2j.ui.client.gui.driver.*;

/**
 * The core web GUI window emulator.
 */
public class GuiWebEmulatedWindow 
extends EmulatedWindowState<Font, BufferedImage>
{
   /** Lock object for shared syncrhonization of the web socket. */
   private Object lock = new Object();
   
   /**
    * Constructor.
    *
    * @param    lock
    *           Object to use for locking. By passing this in, the caller can share the
    *           locking instance with this code.  Use <code>null</code> if an internal
    *           lock object should be created.
    */
   public GuiWebEmulatedWindow(Object lock)
   {
      // TODO
   }

   /**
    * Cause the outer frame to be disposed, as the window is being terminated.
    */
   @Override
   public void quit()
   {
      // TODO
   }

   /**
    * Cause repaint processing to occur.
    */
   @Override
   public void repaint()
   {
      // TODO
   }

   /**
    * Hide or show the window, depending on the {@code visible} flag.
    * 
    * @param    visible
    *           The window visibility state.
    */
   @Override
   public void setWindowVisible(boolean visible)
   {
      // TODO
   }
   
   /**
    * Check if the simulated window is visible.
    * 
    * @return   See above.
    */
   @Override
   public boolean isWindowVisible()
   {
      // TODO
      return false;
   }

   /** 
    * Get the native screen size, in pixel units.
    * 
    * @return   See above.
    */
   @Override
   public NativeDimension getScreenSize()
   {
      // TODO
      return null;
   }

   /**
    * Get the window location on screen.
    * 
    * @return   This window's location.
    */
   @Override
   public NativePoint getWindowLocation()
   {
      // TODO
      return null;
   }

   /**
    * Get the window height.
    * 
    * @return   This window's width in pixels.
    */
   @Override
   public int getHeight()
   {
      // TODO
      return -1;
   }
   
   /**
    * Get the window width.
    * 
    * @return   This window's width in pixels.
    */
   @Override
   public int getWidth()
   {
      // TODO
      return -1;
   }
   
   /**
    * Manage any window state related to iconification.
    * 
    * @param    iconify
    *           <code>true</code> if this window is being iconified, <code>false</code> for
    *           de-iconified.
    */
   @Override
   public void setIconificationState(boolean iconify)
   {
      super.setIconificationState(iconify);
      
      // TODO
      if (iconify)
      {
         
      }
      else
      {
         
      }
   }

   /**
    * Set the mouse cursor to the given type.
    * 
    * @param    type
    *           The cursor type.
    */
   @Override
   public void setCursor(CursorType type)
   {
      int curs = 0;
      
      // TODO: translate the types to something useful
      switch (type)
      {
         case TEXT:
            // curs = Cursor.TEXT_CURSOR;
            break;
         case N_RESIZE:
            // curs = Cursor.N_RESIZE_CURSOR;
            break;
         case NE_RESIZE:
            // curs = Cursor.NE_RESIZE_CURSOR;
            break;
         case E_RESIZE:
            // curs = Cursor.E_RESIZE_CURSOR;
            break;
         case SE_RESIZE:
            // curs = Cursor.SE_RESIZE_CURSOR;
            break;
         case S_RESIZE:
            // curs = Cursor.S_RESIZE_CURSOR;
            break;
         case SW_RESIZE:
            // curs = Cursor.SW_RESIZE_CURSOR;
            break;
         case W_RESIZE:
            // curs = Cursor.W_RESIZE_CURSOR;
            break;
         case NW_RESIZE:
            // curs = Cursor.NW_RESIZE_CURSOR;
            break;
      }
      
      // TODO: set it here
   }

   /**
    * Save and remove the OS window's focus listeners.
    */
   @Override
   public void saveFocusListeners()
   {
      // TODO
   }

   /**                                                 
    * Restore the OS window's focus listeners, which were saved in {@link #saveFocusListeners()}.
    */
   @Override
   public void restoreFocusListeners()
   {
      // TODO
   }

   /**
    * Move this window to top, at the OS level.
    */
   @Override
   public void moveToTop()
   {
      if (!isWindowVisible())
      {
         return;
      }
   
      // TODO
   }
   
   /**
    * Determine if the window is on top of all windows, including OS.
    * 
    * @return   See above.
    */
   @Override
   public boolean isOnTop()
   {
      // TODO
      return false;
   }

   /**
    * Enable or Disable OS-level events for the specified windows.
    * 
    * @param    capture
    *           Flag indicating OS level events are captured (when <code>true</code>).
    */
   @Override
   public void enableEvents(boolean capture)
   {
      // TODO
      if (capture)
      {
      }
      else
      {
      }
   }

   /**
    * Get the metrics of the given font.
    *  
    * @param    f
    *           The font for which the font metrics are to be obtained.
    *           
    * @return   The font metrics.
    */
   @Override
   public FontMetricsHelper getFontMetrics(FontDetails<Font> f)
   {
      synchronized (lock())
      {
         // TODO
         return null;
      }
   }

   /**
    * Get the height of the specified text, using the given font.
    * 
    * @param    text
    *           The text.
    * @param    f
    *           The font used to draw and measure the text.
    *           
    * @return   The text's height.
    */
   @Override
   public int getTextHeight(String text, FontDetails<Font> f)
   {
      synchronized (lock())
      {
         // TODO
         return 0;
      }
   }
   
   /**
    * Draw using a paint operation.
    * 
    * @param    ps
    *           Paint operation parameters.
    */
   @Override
   public void draw(PaintStructure ps)
   {
      // TODO
      switch (ps.id)
      {
         case DRAW_STRING:
            break;
         case DRAW_STRING_SCALED:
            break;
         case DRAW_LINE:
            break;
         case DRAW_RECT:
            break;
         case DRAW_ROUND_RECT:
            break;
         case DRAW_IMAGE:
            break;
         case FILL_RECT:
            break;
         case FILL_ROUND_RECT:
            break;
         case FILL_POLYGON:
            break;
         case DRAW_3D_RECT:
            break;
         case FILL_3D_RECT:
            break;
         case SET_COLOR:
            break;
         case SET_LINE_STROKE:
            break;
         case SET_FONT:
            break;
         case SET_FONT_STYLE:
            break;
         case TRANSLATE:
            break;
         case CLEAR_AREA:
            break;
         case CLEAR:
            break;
         case CLIP:
            break;
         case NO_CLIP:
            break;
         case SET_LOCATION:
            break;
         case RESIZE_WINDOW:
            break;
         case DRAW_HIGHLIGHT:
            break;
         case CLEAR_HIGHLIGHT:
            break;
         case SET_TITLE:
         default:
            break;
      }      
   }
   
   /**
    * Render the given paint operation.  Any graphics context or other resources needed must
    * have already been setup/stored by the caller.
    */
   @Override
   public void flush()
   {
      // TODO
   }
   
   /**
    * Returns display size.
    * 
    * @return   The dimensions in pixels.
    */
   public NativeDimension getDisplaySize()
   {
      // TODO
      return null;
   }

   /**
    * Returns an application-usable display area. For example, a task bar is
    * not counted as the usable area.
    * 
    * @return   The area in pixels.
    */
   public NativeRectangle getDisplayWorkArea()
   {
      // TODO
      return null;
   }
   
   /**
    * Obtain the lock object that can be used to synchronize drawing operations.
    *
    * @return   The shared lock object.
    */
   @Override
   protected Object lock()
   {
      return lock;
   }

   /**
    * Resize the screen buffers so that they will have the new width/height.
    * <p>
    * This will be a no-op if either the width or the height is not a positive number.
    * 
    * @param   width
    *          The new width.
    * @param   height
    *          The new height.
    */
   private void resizeScreenBuffers(int width, int height)
   {
      if (width <= 0 || height <= 0)
      {
         return;
      }
      
      synchronized (lock())
      {
         // TODO
   
         lock().notifyAll();
         repaint();
      }
   }

   /**
    * Convert the generic font style to a Swing font style.
    *
    * @param    style
    *           The font style to convert.
    *
    * @return   The Java Swing font style.
    */
   private int convertFontStyle(FontStyle style)
   {
      int result = 0;
      
      // TODO
      switch (style)
      {
         case BOLD:
            break;
         case ITALIC:
            break;
         case BOLD_ITALIC:
            break;
         case PLAIN:
            break;
      }
      
      return result;
   }
   
}
