/*
** Module   : GuiWebSocket.java
** Abstract : web-sockets implementation which provides a protocol for GUI
**
** Copyright (c) 2015, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**         Golden Code Development Corporation
**                 CONFIDENTIAL
**
** -#- -I- --Date-- --------------------------------Description-----------------------------------
** 001 GES 20150331 Created initial version.
*/

package com.goldencode.p2j.ui.client.gui.driver.web;

import com.goldencode.p2j.ui.client.driver.web.*;

/**
 * This is a WebSocket implementation for GUI which uses a binary protocol to communicate with
 * the javascript (browser-based) desktop simulator.
 * <p>
 * IMPORTANT: Do not use logging anywhere inside this class. When an authentication plugin
 * is running during session establishment with the P2J server using logging no messages are 
 * written into the log and the application is blocked.
 */
public class GuiWebSocket
extends WebClientProtocol
{  
   /**
    * Create a new GUI web socket instance.
    * 
    * @param    lock
    *           Object to use for locking. By passing this in, the caller can share the
    *           locking instance with this code.  Use <code>null</code> if an internal
    *           lock object should be created.
    * @param    callbacks
    *           An instance with hooks to call at specific events.
    * @param    timeout
    *           Web socket timeout.
    * @param    wdtimeout
    *           Watchdog thread timeout.
    */
   public GuiWebSocket(Object lock, ClientProtocolHooks callbacks, long timeout, long wdtimeout)
   {
      super(lock, callbacks, timeout, wdtimeout);
   }
   
   // TODO: extend the messages with GUI-specific processing
}